FROM registry.gitlab.com/rxap/docker/nestjs-server/18.19-alpine:v0.0.1-nightly.1

ARG PROJECT_NAME
ARG PATH_PREFIX
ARG NAME_PREFIX

# PATH_PREFIX should not be required as standalone services dont use it
# RUN if [ -z "$PATH_PREFIX" ]; then exit 1; fi
RUN if [ -z "$PROJECT_NAME" ]; then exit 1; fi

ENV TRAEFIK_SERVICE_NAME=${NAME_PREFIX}${PROJECT_NAME}

ENV TRAEFIK_ROUTER_NAME=${NAME_PREFIX}${PROJECT_NAME}
ENV TRAEFIK_ROUTER_PRIORITY=20
# ensure the $PATH_PREFIX has a preceding slash if not empty
ENV TRAEFIK_ROUTER_PATH_PREFIX=$PATH_PREFIX/

ENV TREAFIK_HEALTH_CHECK_INTERVAL=60s
ENV TREAFIK_HEALTH_CHECK_TIMEOUT=30s
ENV TREAFIK_HEALTH_CHECK_PATH=/health

# required to ensure the husky install is not executed if the package.json contains husky
ENV HUSKY=0

LABEL traefik.enable=true

LABEL traefik.http.services.$TRAEFIK_SERVICE_NAME.loadbalancer.healthCheck.path=$TREAFIK_HEALTH_CHECK_PATH
LABEL traefik.http.services.$TRAEFIK_SERVICE_NAME.loadbalancer.healthCheck.interval=$TREAFIK_HEALTH_CHECK_INTERVAL
LABEL traefik.http.services.$TRAEFIK_SERVICE_NAME.loadbalancer.healthCheck.timeout=$TREAFIK_HEALTH_CHECK_TIMEOUT
LABEL traefik.http.services.$TRAEFIK_SERVICE_NAME.loadbalancer.server.port=$PORT

LABEL traefik.http.routers.$TRAEFIK_ROUTER_NAME.rule=PathPrefix(`$TRAEFIK_ROUTER_PATH_PREFIX`)
LABEL traefik.http.routers.$TRAEFIK_ROUTER_NAME.priority=$TRAEFIK_ROUTER_PRIORITY
LABEL traefik.http.routers.$TRAEFIK_ROUTER_NAME.service=$TRAEFIK_SERVICE_NAME

COPY package.json /app
COPY yarn.lock /app

RUN yarn install --production && yarn cache clean

COPY . /app
